<template>
    <div ref="name" @click.stop="startEditing" @blur="stopEditing" @keydown.enter.prevent="stopEditing" contenteditable="false">{{value}}</div>
</template>

<script setup>

    import { ref } from "vue";

    const props = defineProps({
        value: String,
    });

    const name = ref(null);

    const emit = defineEmits(["change"]);

    const startEditing = () => {
        if (name.value.contentEditable !== "true") {
            name.value.contentEditable = "true";
            window.getSelection().selectAllChildren(name.value);
            name.value.focus();
        }
    };

    const stopEditing = () => {
        if (name.value.contentEditable === "true") {
            name.value.contentEditable = "false";
            if (props.value !== name.value.textContent) {
                emit("change", name.value.textContent);
            }
            document.getSelection().empty();
        }
    };

</script>

<style scoped>

    [contenteditable] {
        border: none;
        border-top: 2px solid transparent;
        border-bottom: 2px dotted transparent;
    }

    [contenteditable]:focus {
        outline: none;
    }

    [contenteditable="false"] {
        cursor: pointer;
    }

    [contenteditable="true"] {
        white-space: nowrap;
        min-width: 100px;
        border-bottom-color: white;
    }

</style>